<?php

namespace Modules\Lpj\Http\Controllers;

use App\Http\Controllers\Controller;
use Exception;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Maatwebsite\Excel\Facades\Excel;
use Modules\Lpj\Exports\IjinUsahaExport;
use Modules\Lpj\Http\Requests\IjinUsahaRequest;
use Modules\Lpj\Models\IjinUsaha;

class IjinUsahaController extends Controller
{
    public $user;
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        return view('lpj::Ijin_usaha.index');
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('lpj::Ijin_usaha.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(IjinUsahaRequest $request)
    {
        $validate = $request->validated();

        if ($validate) {
            try {
                IjinUsaha::create($validate);
                return redirect()
                    ->route('basicdata.ijin_usaha.index')
                    ->with('success', 'Ijin Usaha created successfully');
            } catch (Exception $e) {
                return redirect()
                    ->route('basicdata.ijin_usaha.create')
                    ->with('error', 'Failed to create ijin Usaha');
            }
        }
    }

    /**
     * Show the specified resource.
     */
    public function show($id)
    {
        // return view('lpj::show');
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($id)
    {
        $ijin_usaha = IjinUsaha::find($id);
        return view('lpj::Ijin_usaha.create', compact('ijin_usaha'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(IjinUsahaRequest $request, $id)
    {
        $validate = $request->validated();

        if ($validate) {
            try {
                // Update in database
                $ijin_usaha = IjinUsaha::find($id);
                $ijin_usaha->update($validate);
                return redirect()
                    ->route('basicdata.ijin_usaha.index')
                    ->with('success', 'Ijin Usaha updated successfully');
            } catch (Exception $e) {
                return redirect()
                    ->route('basicdata.ijin_usaha.edit', $id)
                    ->with('error', 'Failed to update ijin$ijin_usaha');
            }
        }
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($id)
    {
        try {
            $ijin_usaha = IjinUsaha::find($id);
            $ijin_usaha->delete();

            echo json_encode(['success' => true, 'message' => 'Ijin Usaha deleted successfully']);
        } catch (Exception $e) {
            echo json_encode(['success' => false, 'message' => 'Failed to delete Ijin Usaha']);
        }
    }

    public function dataForDatatables(Request $request)
    {
        if (is_null($this->user) || !$this->user->can('Ijin_usaha.view')) {
            //abort(403, 'Sorry! You are not allowed to view users.');
        }

        // Retrieve data from the database
        $query = IjinUsaha::query();

        // Apply search filter if provided
        if ($request->has('search') && !empty($request->get('search'))) {
            $search = $request->get('search');
            $query->where(function ($q) use ($search) {
                $q->where('code', 'LIKE', "%$search%");
                $q->orWhere('name', 'LIKE', "%$search%");
            });
        }

        // Apply sorting if provided
        if ($request->has('sortOrder') && !empty($request->get('sortOrder'))) {
            $order  = $request->get('sortOrder');
            $column = $request->get('sortField');
            $query->orderBy($column, $order);
        }

        // Get the total count of records
        $totalRecords = $query->count();

        // Apply pagination if provided
        if ($request->has('page') && $request->has('size')) {
            $page   = $request->get('page');
            $size   = $request->get('size');
            $offset = ($page - 1) * $size; // Calculate the offset

            $query->skip($offset)->take($size);
        }

        // Get the filtered count of records
        $filteredRecords = $query->count();

        // Get the data for the current page
        $data = $query->get();

        // Calculate the page count
        $pageCount = ceil($totalRecords / $request->get('size'));

        // Calculate the current page number
        $currentPage = 0 + 1;

        // Return the response data as a JSON object
        return response()->json([
            'draw'            => $request->get('draw'),
            'recordsTotal'    => $totalRecords,
            'recordsFiltered' => $filteredRecords,
            'pageCount'       => $pageCount,
            'page'            => $currentPage,
            'totalCount'      => $totalRecords,
            'data'            => $data,
        ]);
    }

    public function export()
    {
        return Excel::download(new IjinUsahaExport, 'ijin_usaha.xlsx');
    }
}
